<template>
  <q-dialog v-model="show_dialog" transition-show="scale" transition-hide="scale">
    <q-card class="dialog" style="width: 700px">
      <q-toolbar>
        <q-avatar>
          <img src="logo.svg" />
        </q-avatar>

        <q-toolbar-title class="text-center"
          ><span class="text-weight-bold">{{ selected_block.name }}</span> settings</q-toolbar-title
        >
        <q-btn flat round dense icon="close" v-close-popup />
      </q-toolbar>
      <q-card-section>
        <div class="text-h6" align-center></div>
      </q-card-section>
      <q-card-section class="q-pt-none">
        <div class="row justify-around">
          <div class="col-4 text-center">
            <span>Parameters</span>
            <q-form>
              <div v-for="(value, key) in selected_block.data" :key="key">
                <q-input
                  v-model.number="selected_block.data[key]"
                  type="number"
                  :label="key"
                  :rules="[(val) => (val !== null && val.toString() !== '') || 'Insert a non null value']"
                >
                </q-input>
              </div>
            </q-form>
          </div>
          <div class="col-4 text-center">
            <span>Loggable variables</span>
            <div v-for="(value, key) in selected_block.loggable" :key="'loggable' + key" class="text-left col">
              <q-checkbox v-model="selected_block.loggable[key]" :label="key" color="teal" />
            </div>
            <q-img fit="contain" src="workflow/controller/impedance.svg" style="width: 60%"> </q-img>
          </div>
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from 'vue';
import { RefinedBlock } from 'src/models/workflow';

export default defineComponent({
  emits: ['update:show'],
  props: {
    show: {
      type: Boolean,
      default: false,
    },
    block: {
      type: Object as PropType<RefinedBlock>,
      default: <RefinedBlock>{
        id: '',
        name: '',
        family: '',
        position: { x: 0, y: 0 },
        inputs: {},
        outputs: {},
        loggable: {},
        data: {},
      },
    },
  },

  setup(props, { emit }) {
    const show_dialog = computed({
      get: () => props.show,
      set: (value) => emit('update:show', value),
    });

    const selected_block = computed(() => props.block);

    return {
      show_dialog,
      selected_block,
    };
  },
});
</script>

<style lang="sass" scoped>
.dialog
  max-height: 500px
</style>